%global __jar_repack %{nil}

%define rel 3

%define svn 1

%if %{svn}
%define rev 143
%define pre 0.
%endif

%define upname firetray

%define xr_min_version 10
%define ff_min_version 10
%define tb_min_version 10
%define sm_min_version 2.7

%define ft_guid \{9533f794-00b4-4354-aa15-c2bbda6989f8\}

%define ff_guid \{ec8030f7-c20a-464f-9b0e-13a3a9e97384\}
%define tb_guid \{3550f703-e582-4d05-9a08-453d09bdfdc6\}
%define sm_guid \{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a\}
%define cz_guid \{59c81df5-4b7a-477b-912d-4e0fdf64e5f2\}

%define mz_ext_dir %{_libdir}/mozilla/extensions/

Name:           mozilla-firetray
Version:        0.3.6
%if %{svn}
Release:        %{?pre}%{rel}.%{rev}svn%{?dist}
%else
Release:        %{rel}%{?dist}  
%endif      
Summary:        A system tray add on for mozilla

Group:          User Interface/X
License:        GPLv2 and CC-BY-SA
URL:            http://code.google.com/p/firetray
%if %{svn}
# This is an svn snapshot, to get this tarball, use :
# svn checkout -r %%{rev} http://firetray.googlecode.com/svn/trunk/ %%{name}-%%{version}-%%{rev}svn
# cd %%{name}-%%{version}-%%{rev}svn
# svn export . %%{name}-%%{version}-%%{rev}svn
# tar cjf %%{name}-%%{version}-%%{rev}svn.tar.bz2 %%{name}-%%{version}-%%{rev}svn         
Source0:        %{name}-%{version}-%{rev}svn.tar.bz2
%else
Source0:        http://%{upname}.googlecode.com/files/%{upname}-%{version}-src.zip
%endif

# Patch0:  Backported from upstream svn
#          http://code.google.com/p/firetray/source/detail?r=125
Patch0:    %{name}-%{version}-bump-max-version-numbers.patch

# Patch1:  Check for install.rdf before removing it during the build
#          http://code.google.com/p/firetray/issues/detail?id=212
Patch1:    %{name}-%{version}-check-for-install-rdf-before-removing-it.patch

#Patch2    http://code.google.com/p/firetray/issues/detail?id=191
Patch2:    %{name}-%{version}-use-arch-dep-mozconfig.patch

# Patch3 : use the window icon
#          http://code.google.com/p/firetray/issues/detail?id=190
Patch3:    %{name}-%{version}-use-first-window-icon.patch

# Patch4 : Add a missing hunk that was missing during the merge
#          http://code.google.com/p/firetray/issues/detail?id=189
Patch4:    %{name}-%{version}-add-chatzilla-support.patch

# Patch5:  http://code.google.com/p/firetray/issues/detail?id=213
#          fixes and workarounds for gecko 9 and newer
Patch5:    %{name}-%{version}-new-gecko-changes.patch

BuildRequires:  xulrunner-devel

BuildRequires:  scons
BuildRequires:  zip unzip

%description
Firetray is a system tray add on for mozilla, current features are :

- adds tray icon for all mozilla based application
- Show number of unread mails in the tray icon (Thunderbird, Seamonkey)
- close button hides to tray
- ability to start minimized to tray
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%package core
Summary:        Core files for Mozilla Firetray Extension
%if %{fedora} > 15
Obsoletes:      mozilla-firetay-sunbird < %{version}-%{release}
%endif

%description core
Firetray is a system tray add on for mozilla, this package contains
the files needed for all mozilla applications to use the Firetray extension.
But it doesn't do anything by itself.

If you want to enable firetray functionality for a mozilla application,
install the corresponding package; for example, if you want to enable
it for Thunderbird, install mozilla-firetray-thunderbird package.

%package firefox
Summary:        System tray extension for firefox
Requires:       firefox >= %{ff_min_version}
Requires:       %{name}-core = %{version}-%{release}
Requires:       %{_libdir}/%{name}-%{version}

%description firefox
Firetray is a system tray add on for firefox, current features are :

- adds tray icon
- close button hides to tray
- ability to start minimized to tray
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%package thunderbird
Summary:        System tray extension for Thunderbird
Requires:       thunderbird >= %{tb_min_version}
Requires:       %{name}-core = %{version}-%{release}
Requires:       %{_libdir}/%{name}-%{version}

%description thunderbird
Firetray is a system tray add on for Thunderbird, current features are :

- adds tray icon
- Show number of unread mails in the tray icon
- close button hides to tray
- ability to start minimized to tray
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%package seamonkey
Summary:        System tray extension for seamonkey
Requires:       seamonkey >= %{sm_min_version}
Requires:       %{name}-core = %{version}-%{release}
Requires:       %{_libdir}/%{name}-%{version}

%description seamonkey
Firetray is a system tray add on for seamonkey, current features are :

- adds tray icon
- Show number of unread mails in the tray icon
- close button hides to tray
- ability to start minimized to tray
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%package chatzilla
Summary:        System tray extension for chatzilla
Requires:       xulrunner >= %{xr_min_version}
Requires:       %{name}-core = %{version}-%{release}
Requires:       %{_libdir}/%{name}-%{version}

%description chatzilla
Firetray is a system tray add on for chatzilla, current features are :

- adds tray icon
- close button hides to tray
- ability to start minimized to tray
- Custom tray icon
- Hotkey for Hide/Unhide
- Handle mouse scrolls on tray icon

%prep
%if %{svn}
%setup -q -n %{name}-%{version}-%{rev}svn
%else
%setup -q -c %{upname}-%{version}
%endif

%patch0 -p1 -b .bump-max-version-numbers
%patch1 -p1 -b .check-for-install-rdf-before-removing-it
%patch2 -p1 -b .use-arch-dep-mozconfig
%patch3 -p1 -b .use-our-icons
%patch4 -p1 -b .add-chatzilla-support
%patch5 -p1 -b .newer-gecko-changes

# Mozilla seems to be willing to get rid of PRbool
sed -i 's|PRBool|bool|g' components/nsTray.cpp

# Make sure we don't ship prebuilt stuff
find . \( -name '*.xpi' -o -name '*.jar' -o -name '*.xpt' -o -name '*.so' \) -exec rm -f '{}' \;

chmod -x components/pixmaps/songbirdegg.xpm

%build
export CXXFLAGS="%{optflags}"
sh build.sh --dynamic-linking \
            --gecko19-compat \
            --release-name=%{release}

%install
mkdir -p $RPM_BUILD_ROOT%{mz_ext_dir}{%{ff_guid},%{tb_guid},%{sm_guid},%{?sb_guid},%{cz_guid}}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}

unzip %{upname}-%{version}-%{release}.xpi -d $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}

#now symlink the products extension's directories to the core extension directory

for i in {%{ff_guid},%{tb_guid},%{sm_guid},%{cz_guid}};do
    pushd $RPM_BUILD_ROOT%{mz_ext_dir}$i
        ln -s %{_libdir}/%{name}-%{version} %{ft_guid}
    popd
done

%pretrans firefox -p <lua>
st=posix.stat("%{mz_ext_dir}%{ff_guid}/%{ft_guid}")
if st and st.type == "directory" then
  os.execute("rm -rf %{mz_ext_dir}%{ff_guid}/%{ft_guid}")
end


%pretrans thunderbird -p <lua>
st=posix.stat("%{mz_ext_dir}%{tb_guid}/%{ft_guid}")
if st and st.type == "directory" then
  os.execute("rm -rf %{mz_ext_dir}%{tb_guid}/%{ft_guid}")
end

%pretrans seamonkey -p <lua>
st=posix.stat("%{mz_ext_dir}%{sm_guid}/%{ft_guid}")
if st and st.type == "directory" then
  os.execute("rm -rf %{mz_ext_dir}%{sm_guid}/%{ft_guid}")
end

%pretrans chatzilla -p <lua>
st=posix.stat("%{mz_ext_dir}%{cz_guid}/%{ft_guid}")
if st and st.type == "directory" then
  os.execute("rm -rf %{mz_ext_dir}%{cz_guid}/%{ft_guid}")
end

%files core
%defattr(-,root,root,-)
%doc License.txt changes
%{_libdir}/%{name}-%{version}

%files firefox
%defattr(-,root,root,-)
%doc License.txt changes
%{mz_ext_dir}%{ff_guid}/%{ft_guid}

%files thunderbird
%defattr(-,root,root,-)
%doc License.txt changes
%{mz_ext_dir}%{tb_guid}/%{ft_guid}

%files seamonkey
%defattr(-,root,root,-)
%doc License.txt changes
%{mz_ext_dir}%{sm_guid}/%{ft_guid}

%files chatzilla
%defattr(-,root,root,-)
%doc License.txt changes
%{mz_ext_dir}%{cz_guid}/%{ft_guid}


%changelog
* Thu Feb 09 2012 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.3.6-0.3.143svn
- More lua %%pretrans scripts 

* Thu Feb 02 2012 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.3.6-0.2.143svn
- Add patches from http://code.google.com/p/firetray/issues/detail?id=213
  to build against gecko 10 

* Mon Jan 16 2012 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.3.6-0.1.143svn
- Update to latest snapshot, fixes rhbz #754204

* Thu Sep 08 2011 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.3.1-1
- Update to 0.3.1
- Obsolete mozilla-firetray-sunbird on fedora >= 16, since sunbird have
  been removed on these
- Remove BuildRoot tag
- Better fix to load the correct window icon on systray
- Drop patches merged or that have better fixes upstream

* Thu Oct 28 2010 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.2.8-5
- Spec cleanup
- Add workaround for rhbz #646523

* Wed Sep 29 2010 jkeating - 0.2.8-4
- Rebuilt for gcc bug 634757

* Tue Sep 14 2010 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.2.8-3
- Fix for the new way of xpcom registration

* Fri Aug 05 2010 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.2.8-2
- Backport patch from upstream svn to use the system's CXXFLAGS, fixes
  rhbz #621683

* Fri Jul 16 2010 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.2.8-1
- New upstream release
- Drop some patches ( merged upstream or fixed ) :
  + mozilla-firetray-0.2.6-fix-max-versions.patch
  + mozilla-firetray-0.2.6-fix-include-path-and-cxxflags.patch
  + mozilla-firetray-0.2.6-handle-exception.patch
  + mozilla-firetray-0.2.6-fix-sunbird-chrome-path.patch
  + mozilla-firetray-0.2.6-disable-multimedia-keys.patch

* Sat May 15 2010 Hicham HAOUARI <hicham.haouari@gmail.com> - 0.2.6-1
- Initial package
